# Build Qt

SET(QT_PREFIX qt6)

SET(QT_MAJOR 6)
SET(QT_MINOR 1)
SET(QT_BUGFIX 0)

SET(QT_URL https://download.qt.io/official_releases/qt/${QT_MAJOR}.${QT_MINOR}/${QT_MAJOR}.${QT_MINOR}.${QT_BUGFIX}/single/qt-everywhere-src-${QT_MAJOR}.${QT_MINOR}.${QT_BUGFIX}.tar.xz)

# Configure Qt
SET(BUILD_qtx11extras OFF CACHE INTERNAL "")
SET(BUILD_qtandroidextras OFF CACHE INTERNAL "")
SET(BUILD_qtserialport OFF CACHE INTERNAL "")
SET(BUILD_qtserialbus OFF CACHE INTERNAL "")
SET(BUILD_qtactiveqt OFF CACHE INTERNAL "")
SET(BUILD_qtxmlpatterns OFF CACHE INTERNAL "")
SET(BUILD_qtdeclarative OFF CACHE INTERNAL "")
SET(BUILD_qtscxml OFF CACHE INTERNAL "")
SET(BUILD_qtpurchasing OFF CACHE INTERNAL "")
SET(BUILD_qtcanvas3d OFF CACHE INTERNAL "")
SET(BUILD_qtwayland OFF CACHE INTERNAL "")
SET(BUILD_qtconnectivity OFF CACHE INTERNAL "")
SET(BUILD_qtwebsockets OFF CACHE INTERNAL "")
SET(BUILD_qtwebchannel OFF CACHE INTERNAL "")
SET(BUILD_qtsensors OFF CACHE INTERNAL "")
SET(BUILD_qtdatavis3d OFF CACHE INTERNAL "")
SET(BUILD_qtquickcontrols2 OFF CACHE INTERNAL "")
SET(BUILD_qtquickcontrols OFF CACHE INTERNAL "")
SET(BUILD_qtvirtualkeyboard OFF CACHE INTERNAL "")
SET(BUILD_qtlocation OFF CACHE INTERNAL "")
SET(BUILD_qtwebengine OFF CACHE INTERNAL "")
SET(BUILD_qtwebview OFF CACHE INTERNAL "")
SET(BUILD_qtscript OFF CACHE INTERNAL "")
SET(BUILD_qttranslations OFF CACHE INTERNAL "")
SET(BUILD_qtdoc OFF CACHE INTERNAL "")
SET(BUILD_qt3d OFF CACHE INTERNAL "")
SET(BUILD_qt5compat OFF CACHE INTERNAL "")
SET(BUILD_qttools OFF CACHE INTERNAL "")
SET(BUILD_qtcoap OFF CACHE INTERNAL "")
SET(BUILD_qtlottie OFF CACHE INTERNAL "")
SET(BUILD_qtmqtt OFF CACHE INTERNAL "")
SET(BUILD_qtopcua OFF CACHE INTERNAL "")
SET(BUILD_qtquick3d OFF CACHE INTERNAL "")
SET(BUILD_qtquicktimeline OFF CACHE INTERNAL "")
SET(BUILD_qtcharts OFF CACHE INTERNAL "")
SET(BUILD_sql OFF CACHE INTERNAL "")
SET(QT_BUILD_EXAMPLES FALSE CACHE INTERNAL "")
SET(QT_BUILD_TESTS FALSE CACHE INTERNAL "")
SET(INPUT_xcb no CACHE INTERNAL "")
SET(INPUT_glib no CACHE INTERNAL "")
SET(INPUT_harfbuzz no CACHE INTERNAL "")
SET(INPUT_sql_db2 no CACHE INTERNAL "")
SET(INPUT_sql_ibase no CACHE INTERNAL "")
SET(INPUT_sql_mysql no CACHE INTERNAL "")
SET(INPUT_sql_oci no CACHE INTERNAL "")
SET(INPUT_sql_odbc no CACHE INTERNAL "")
SET(INPUT_sql_psql no CACHE INTERNAL "")
SET(INPUT_sql_sqlite no CACHE INTERNAL "")
SET(INPUT_cups no CACHE INTERNAL "")
SET(INPUT_qml_debug no CACHE INTERNAL "")

# Add Json
FETCHCONTENT_DECLARE(
  ${QT_PREFIX}
  PREFIX ${QT_PREFIX}
  URL ${QT_URL}
)

FETCHCONTENT_GETPROPERTIES(${QT_PREFIX})

IF(NOT ${QT_PREFIX}_POPULATED)
  FETCHCONTENT_POPULATE(${QT_PREFIX})
  ADD_SUBDIRECTORY(${${QT_PREFIX}_SOURCE_DIR} ${${QT_PREFIX}_BINARY_DIR})
ENDIF()
